using System.Collections.Generic;
using BigSock.Interact;
using Cinemachine;
using UnityEngine;


namespace Bigsock
{
    public class FollowPlayer : MonoBehaviour
    {
        [SerializeField]
        private NeighbourMapGenerator neighborMapGenerator;
        [SerializeField]
        private CinemachineConfiner2D cameraMap;

        private int levels = 1;


        Vector3 offset = new Vector3(0, 0, -10);
        int i = 0;

        GameObject[] boss;
        GameObject player;
        GameObject[] enemies;
        GameObject[] Chest;
        List<GameObject> chests;
        GameObject stair;
        private int roomNr = 0;
        bool stairs_down;

        void Start()
        {
            chests = new List<GameObject>();
            neighborMapGenerator.RunProceduralGeneration();
            player = GameObject.Find("BigSock");
            stair = GameObject.Find("Stairs(Clone)");
            Chest = GameObject.FindGameObjectsWithTag("Chest");
            foreach(GameObject c in Chest)
            {
                chests.Add(c);
                c.SetActive(false);
            }
            stairs_down = stair.GetComponent<Stairs>().stairs_touch;
            stair.SetActive(false);
        }

        void LateUpdate()
        {
            boss = GameObject.FindGameObjectsWithTag("Boss");
            enemies = GameObject.FindGameObjectsWithTag((roomNr).ToString());
            if (boss.Length == 0 && levels <= 1)
            {
                stair.SetActive(true);
                stairs_down = stair.GetComponent<Stairs>().stairs_touch;
            }
            

            if (stairs_down)
            {
                roomNr = 0;
                foreach(GameObject c in chests)
                {
                    DestroyImmediate(c);
                }
                DestroyImmediate(stair);
                chests.Clear();
                TilemapGenerator.resetMaps();
                TilemapGenerator.SetRoomIDZero();
                player.transform.position = new Vector3(9,5,0);
                neighborMapGenerator.RunProceduralGeneration();
                Chest = GameObject.FindGameObjectsWithTag("Chest");
                stair = GameObject.Find("Stairs(Clone)");
                stairs_down = stair.GetComponent<Stairs>().stairs_touch;
                foreach (GameObject c in Chest)
                {
                    if(c != null)
                    {
                        c.SetActive(false);
                        chests.Add(c);
                    }
                }
                stair.SetActive(false);
                levels++;
            }

            int i = 0;
            if(i == 0) {
                cameraMap.InvalidateCache();
            }

            if (enemies.Length == 0)
            {
                chests[roomNr].SetActive(true);
                if(roomNr + 1 < NeighbourMapGenerator.GetRoomListCount() - 1)
                {
                    roomNr++;
                }
            }
            if(boss.Length == 0)
            {
                chests[1 + roomNr].SetActive(true);
            }
        }

        private void OnDestroy()
        {
            roomNr = 0;
            foreach (GameObject c in chests)
            {
                DestroyImmediate(c);
            }
            DestroyImmediate(stair);
            NeighbourMapGenerator.ClearRoomList();
            TilemapGenerator.SetRoomIDZero();
            TilemapGenerator.resetMaps();
        }
    }
}
