using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;


namespace BigSock.UI
{
    public class AbilityElement : MonoBehaviour
    {
        private Slider ChargeSlider, ReloadSlider;

        public AbilityElement WithCharge(int? value = null, int? maxValue = null)
        {
            if (value != null) ChargeSlider.value = value.Value;

            if (maxValue != null) ChargeSlider.maxValue = maxValue.Value;
            return this;
        }

        public AbilityElement WithReload(int? value = null, int? maxValue = null)
        {
            if (value != null) ReloadSlider.value = value.Value;

            if (maxValue != null) ReloadSlider.maxValue = maxValue.Value;
            return this;
        }



        // Start is called before the first frame update
        void Start()
        {
            ChargeSlider = transform.Find("ChargeSlider").GetComponent<Slider>();
            ReloadSlider = transform.Find("ReloadSlider").GetComponent<Slider>();
        }

        // Update is called once per frame
        void Update()
        {

        }
    }
}
